#ifndef WViscFluxes_H
#define WViscFluxes_H

#include "dart.h"
#include "wBLRegion.h"
#include <Eigen/Dense>
#include <vector>
#include <string>

namespace dart
{

class DART_API ViscFluxes
{
public:
  ViscFluxes();
  ~ViscFluxes();
  Eigen::Vector<double, 5> ComputeFluxes(size_t iPoint, BLRegion *bl);
  Eigen::Matrix<double, 5, 5> ComputeJacobian(size_t iPoint, BLRegion *bl, Eigen::Vector<double, 5> &sysRes, double eps);
private:
  Eigen::Vector<double, 5> BLlaws(size_t iPoint, BLRegion *bl, std::vector<double> u);
  double AmplificationRoutine(double hk, double ret, double theta);
  void LaminarClosures(size_t iPoint, BLRegion *bl);
  void TurbulentClosures(size_t iPoint, BLRegion *bl);

};
} // namespace dart
#endif //WViscFluxes_H