#include "wViscSolver.h"
#include "wBLRegion.h"
#include "wTimeSolver.h"
#include <iostream>
#include <vector>


using namespace tbox;
using namespace dart;


ViscSolver::ViscSolver(double _Re, double _Minf, double _CFL0)
{

  /* Freestream parameters */
  Re = _Re;
  Minf = _Minf;

  /* User input numerical parameters */
  CFL0 = _CFL0;

  /* Parameters */
  double cd = 0.0;

  std::cout << "--- Viscous solver setup ---\n"
              << "Reynolds number: " << Re
              << "Freestream Mach number: " << Minf
              << "Initial CFL number: " << CFL0
              << std::endl;

  /* Initialzing boundary layer */

  //std::vector<dart::BLRegion> bl;

  std::cout << "--- Jusqu'ici ok ---\n" << std::endl;

  for (size_t i=0; i<3; ++i)
  {
    std::cout << "yop" << std::endl;
    BLRegion *region = new BLRegion();
    std::cout << "yop2" << std::endl;
    bl.push_back(region);
  } // end for

  tSolver = new TimeSolver(CFL0, Minf);

  bl[0]->name = "upper";
  bl[1]->name = "lower";
  bl[2]->name = "wake";

  std::cout << " Boundary layer initialized.\n" << std::endl;

} // end ViscSolver


ViscSolver::~ViscSolver()
{
  for (size_t i=0; i<bl.size(); ++i){
    delete bl[i];
  } // end for

  delete tSolver;

  std::cout << "~ViscSolver()\n";


} // end ~ViscSolver

void ViscSolver::InitMeshes(size_t region, std::vector<double> locM, std::vector<double> globM)
{
  bl[region]->SetMesh(locM, globM);
}

void ViscSolver::SetInvBC(size_t region, std::vector<double> _Ue,
                                         std::vector<double> _Me,
                                         std::vector<double> _Rhoe)
{
  bl[region]->SetInvBC(_Ue, _Me, _Rhoe);
}


int ViscSolver::Run(){
  std::cout << "Entered run"
            << std::endl;

  /* Set boundary condition */

  bl[0]->SetStagBC(Re);
  bl[1]->SetStagBC(Re);

  /* Loop over the regions */

  for (size_t iRegion = 0; iRegion < bl.size(); ++iRegion){

    /* Loop over points */ 

    for (size_t iPoint = 1; iPoint < bl[iRegion]->GetnMarkers(); ++iPoint){

      tSolver->InitialCondition(iPoint, bl[iRegion]);

      std::cout << "Point " << iPoint << " H " << bl[iRegion]->U[iPoint*bl[iRegion]->GetnVar() + 3] << std::endl;

      //tSolver->Integration(iPoint, bl[iRegion]);

    }

    
  }
  return 0; // Successfull exit
};